# functioncalls in order to administer dristributionlists 

function create-distributionlist {
    [CmdletBinding()]
    param ($WebserviceConnection, $displayname, $mailaddress)
    
    $result = $webserviceconnection.CreateMaillist($displayname, $mailaddress)
    $result
}

function get-distributionlist {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress)

    $distributionlists = $WebserviceConnection.getMailLists()
    $distributionlist = $distributionlists | ? { $_.emailaddress -match $mailaddress }   
    
    $distributionlist
}

function remove-distributionlist {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress)

    $distributionlists = $WebserviceConnection.getMailLists()
    $distributionlist = $distributionlists | ? { $_.emailaddress -match "Zoo@mustereinrichtung.rwth-aachen.de" }   

    $result = $WebserviceConnection.RemoveMailList($distributionlist.SamAccountName)
    $result
}

function change-distributionlistowner {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress, $newowner)

    $secondaryowner = ""
    $result = $WebserviceConnection.SetMaillistOwner($mailaddress, $newowner, $secondaryowner)
    $result
}

function change-distributionlistglobaladressbookvisibility {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress)

    $distributionlist = get-distributionlist -WebserviceConnection $WebserviceConnection -mailaddress $mailaddress

    if ($distributionlist.ShowInGlobalAddressbook) {
        $result = $WebserviceConnection.SetMaillistAddToGlobalAddressbook($distributionlist.SamAccountName, $false)
    }
    else {
        $result = $WebserviceConnection.SetMaillistAddToGlobalAddressbook($distributionlist.SamAccountName, $true)
    }
    $result
}

function change-distributionlistemailaddresses {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress, $newmailaddress)

    $distributionlist = get-distributionlist -WebserviceConnection $WebserviceConnection -mailaddress $mailaddress
    $result = $WebserviceConnection.setMaillistEmailaddresses($distributionlist.SamAccountName, $newmailaddress)
    $result
}

function change-distributionlistdisplayname {
    [CmdletBinding()]
    param ($WebserviceConnection, $mailaddress, $newmdisplayname)

    $distributionlist = get-distributionlist -WebserviceConnection $WebserviceConnection -mailaddress $mailaddress
    $result = $WebserviceConnection.setMaillistDisplayname($distributionlist.SamAccountName, $newdisplayname)
    $result
}

function add-distributiongroupmember {
    [CmdletBinding()]
    param ($WebserviceConnection, $distributionlist, $newmember)

    $mailboxes = $webserviceconnection.getMailboxList()
    $mailbox = $mailboxes | ? { $_.emailaddress -like $newmember }

    $result = $WebserviceConnection.addMailboxToMaillist($distributionlist, $mailbox.upn)
    $result
}

function remove-distributiongroupmember {
    [CmdletBinding()]
    param ($WebserviceConnection, $distributionlist, $member)

    $mailboxes = $webserviceconnection.getMailboxList()
    $mailbox = $mailboxes | ? { $_.emailaddress -like $member }

    $result = $WebserviceConnection.RemoveMailboxFromMaillist($distributionlist, $mailbox.upn)
    $result
}